#!/usr/bin/env python
"""
flag.py - Pluvo Flag Datatype
Author: Sean B. Palmer, inamidst.com
"""

import sys

class Flag(object): 
   def __init__(self, value): 
      # @@ Long, short, name...
      self.value = value

   def __repr__(self): 
      return "Flag(%r)" % self.value

   def __call__(self, env, *args): 
      if len(args) == 1: 
         block = args[0]

         if self.value in sys.argv: 
            if block is not None: 
               return env.evaluate(block)
            return True
         return False
      elif len(args) == 3: 
         ore, cond, block = args[0], args[1], args[2]
         if (self.value in sys.argv) or env.evaluate(cond): 
            if block is not None: 
               return env.evaluate(block)
            return True
         return False

def trim(string): 
   return string.strip(' \t\r\n')

if __name__ == '__main__': 
   print trim(__doc__)
