#!/usr/bin/env python
"""
number.py - Pluvo Number Datatype
Author: Sean B. Palmer, inamidst.com
"""

import decimal

class Number(object): 
   def __init__(self, *args): 
      # See String.__init__ for more details about the mess
      self.num = decimal.Decimal(str(args[-1]))

   def __str__(self): 
      return str(self.num)

   def __hash__(self): 
      return hash(self.num)

   def __eq__(self, other): 
      return self.num == other

   def __add__(self, num): 
      return Number(self.num + num)

   def __sub__(self, num): 
      return Number(self.num - num.num)

   def __getattr__(self, attr): 
      return getattr(self.num, attr)

def trim(string): 
   return string.strip(' \t\r\n')

if __name__ == '__main__': 
   print trim(__doc__)
