#!/usr/bin/env python
"""
regexp.py - Pluvo Regexp Datatype
Author: Sean B. Palmer, inamidst.com
"""

import re

class Regexp(object): 
   def __init__(self, pattern): 
      self.pattern = pattern

   def __repr__(self): 
      return 'S%r' % self.pattern

   def __str__(self): 
      return self.pattern

   def __call__(self, env, string, block=None): 
      r = re.compile(self.pattern)
      if r.search(str(string)): 
         if block is not None: 
            return env.evaluate(block)
         return True
      return False

def trim(string): 
   return string.strip(' \t\r\n')

if __name__ == '__main__': 
   print trim(__doc__)
