#!/usr/bin/env python

import sys, os.path
from distutils.core import setup

def main(): 
   if not os.path.isfile('Makefile'): 
      import textwrap
      print >> sys.stderr, textwrap.dedent("""\
         This script should normally be run as follows: 
            $ ./configure
            $ make
            # make install

         But to force Python setup.py installation, try: 
            $ touch Makefile
            # python setup.py install

         -- 
         Sean B. Palmer, inamidst.com
      """)
      sys.exit(1)

   f = open('library/version')
   version = f.read()
   version = version.rstrip('\r\n')
   f.close()

   setup(name='pluvo', 
         version=version, 
         url='http://inamidst.com/pluvo/', 
         author='Sean B. Palmer', 
         author_email='pluvo\x40miscoranda\x2Ecom', 
         packages=['pluvo', 'pluvo.datatypes', 'pluvo.library'], 
         package_dir={'pluvo': ''}, 
         # For some reason, package_data doesn't work
         package_data={
            # 'pluvo': ['version'], 
            'pluvo.library': ['*.py', 'version']
         }, 
         data_files=[
            ('/usr/local/bin', ['pluvo'])
         ])

if __name__ == '__main__': 
   main()
